--SavedVariables Setup
local BeamMeUpDeja, private = ...

private.defaults = {
    -- If you have any general settings for you addon,
    -- list them here, or just leave the table empty.
}

local loader = CreateFrame("Frame")
	loader:RegisterEvent("ADDON_LOADED")
	loader:SetScript("OnEvent", function(self, addon)
		if addon ~= BeamMeUpDeja then 
			local function initDB(db, defaults)
				if type(db) ~= "table" then db = {} end
				if type(defaults) ~= "table" then return db end
				for k, v in pairs(defaults) do
					if type(v) == "table" then
						db[k] = initDB(db[k], v)
					elseif type(v) ~= type(db[k]) then
						db[k] = v
					end
				end
			return db
			end

		BeamMeUpDejaDBPC = initDB(BeamMeUpDejaDBPC, private.defaults)
		private.db = BeamMeUpDejaDBPC -- add this
		self:UnregisterEvent("ADDON_LOADED")
		-- Don't place any frames here
		end
	end)

BeamMeUpDeja = {};

local _, private = ...
	private.defaults.optpanelDefaults = {
		point = "RIGHT", 
		relativeTo = "UIParent", 
		relativePoint = "RIGHT", 
		xOffset = 0, 
		yOffset = 0,
	}	
	
BeamMeUpDeja.panel = CreateFrame( "Frame", "BeamMeUpDejaPanel", UIParent );
-- Register in the Interface Addon Options GUI
-- Set the name for the Category for the Options Panel
BeamMeUpDeja.panel.name = "BeamMeUpDeja";
-- Add the panel to the Interface Options
InterfaceOptions_AddCategory(BeamMeUpDeja.panel);

-- Make a child panel
-- BeamMeUpDeja.childpanel = CreateFrame( "Frame", "BeamMeUpDejaChild", BeamMeUpDeja.panel);
-- BeamMeUpDeja.childpanel.name = "MyChild";
-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
-- BeamMeUpDeja.childpanel.parent = BeamMeUpDeja.panel.name;
-- Add the child to the Interface Options
-- InterfaceOptions_AddCategory(BeamMeUpDeja.childpanel);

--Panel Title
local BMUDtitle=CreateFrame("Frame", "BMUDtitle", BeamMeUpDejaPanel)
	BMUDtitle:SetPoint("TOPLEFT", 5, -5)
	BMUDtitle:SetScale(2.0)
	BMUDtitle:SetWidth(150)
	BMUDtitle:SetHeight(50)
	BMUDtitle:Show()

local BMUDtitleFS = BMUDtitle:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	BMUDtitleFS:SetText('|cff00c0ffBeamMeUpDeja|r')
	BMUDtitleFS:SetPoint("TOPLEFT", 0, 0)
	BMUDtitleFS:SetFont("Fonts\\FRIZQT__.TTF", 10)
	
BMUDresetcheck = CreateFrame("Button", "BMUDResetButton", BeamMeUpDejaPanel, "UIPanelButtonTemplate")
	BMUDresetcheck:ClearAllPoints()
	BMUDresetcheck:SetPoint("BOTTOMLEFT", 5, 5)
	BMUDresetcheck:SetScale(1.25)
	BMUDresetcheck:SetWidth(125)
	BMUDresetcheck:SetHeight(30)
	_G[BMUDresetcheck:GetName() .. "Text"]:SetText("Reset to Default")
	BMUDresetcheck:SetScript("OnClick", function (self, button, down)
 		BeamMeUpDejaDBPC = private.defaults;
		ReloadUI();
end)

 BMUDlockcheck = CreateFrame("CheckButton", "BeamMeUpDejaLockAll", BeamMeUpDejaPanel, "InterfaceOptionsCheckButtonTemplate")
	BMUDlockcheck:ClearAllPoints()
	BMUDlockcheck:SetPoint("TOPLEFT", 25, -50)
	BMUDlockcheck:SetScale(1.25)
	_G[BMUDlockcheck:GetName() .. "Text"]:SetText("Lock all frames")
	BMUDlockcheck.tooltipText = 'Checked locks all BeamMeUpDeja frames. Unchecked unlocks all BeamMeUpDeja frames.' --Creates a tooltip on mouseover.
	BMUDlockcheck:SetChecked(true)
	
	BMUDlockcheckframe=CreateFrame("Frame", "BMUDlockcheckframe", UIParent)
	BMUDlockcheckframe:SetClampedToScreen(1)
	BMUDlockcheckframe:SetFrameStrata(BACKGROUND)
	BMUDlockcheckframe:SetFrameLevel("1")
	BMUDlockcheckframe:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT")
	BMUDlockcheckframe:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT")
	BMUDlockcheckframe:Hide()
	
	-- Lock/Unlock Frames
	BMUDlockcheck:SetScript("OnClick", function(self,button,down) 
		if self:GetChecked(true) then
			BMUDlockcheckframe:Hide()
		else
			BMUDlockcheckframe:Show()
		end
	end)
	
--Open Categaories Fix
do
	local function get_panel_name(panel)
		local tp = type(panel)
		local cat = INTERFACEOPTIONS_ADDONCATEGORIES
		if tp == "string" then
			for i = 1, #cat do
				local p = cat[i]
				if p.name == panel then
					if p.parent then
						return get_panel_name(p.parent)
					else
						return panel
					end
				end
			end
		elseif tp == "table" then
			for i = 1, #cat do
				local p = cat[i]
				if p == panel then
					if p.parent then
						return get_panel_name(p.parent)
					else
						return panel.name
					end
				end
			end
		end
	end

	local function InterfaceOptionsFrame_OpenToCategory_Fix(panel)
		if doNotRun or InCombatLockdown() then return end
		local panelName = get_panel_name(panel)
		if not panelName then return end -- if its not part of our list return early
		local noncollapsedHeaders = {}
		local shownpanels = 0
		local mypanel
		local t = {}
		local cat = INTERFACEOPTIONS_ADDONCATEGORIES
		for i = 1, #cat do
			local panel = cat[i]
			if not panel.parent or noncollapsedHeaders[panel.parent] then
				if panel.name == panelName then
					panel.collapsed = true
					t.element = panel
					InterfaceOptionsListButton_ToggleSubCategories(t)
					noncollapsedHeaders[panel.name] = true
					mypanel = shownpanels + 1
				end
				if not panel.collapsed then
					noncollapsedHeaders[panel.name] = true
				end
				shownpanels = shownpanels + 1
			end
		end
		local Smin, Smax = InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
		if shownpanels > 15 and Smin < Smax then 
		  local val = (Smax/(shownpanels-15))*(mypanel-2)
		  InterfaceOptionsFrameAddOnsListScrollBar:SetValue(val)
		end
		doNotRun = true
		InterfaceOptionsFrame_OpenToCategory(panel)
		doNotRun = false
	end

	hooksecurefunc("InterfaceOptionsFrame_OpenToCategory", InterfaceOptionsFrame_OpenToCategory_Fix)
end

--BMUD Slash Setup
local RegisteredEvents = {};
local BMUDslash = CreateFrame("Frame", "BeamMeUpDejaSlash", UIParent)

BMUDslash:SetScript("OnEvent", function (self, event, ...) 
	if (RegisteredEvents[event]) then 
	return RegisteredEvents[event](self, event, ...) 
	end
end)

function RegisteredEvents:ADDON_LOADED(event, addon, ...)
	if (addon == "BeamMeUpDeja") then
		SLASH_BEAMMEUPDEJA1 = '/bmud'
		SlashCmdList["BeamMeUpDeja"] = function (msg, editbox)
			BeamMeUpDeja.SlashCmdHandler(msg, editbox)	
		end
		DEFAULT_CHAT_FRAME:AddMessage("BeamMeUpDeja loaded successfully. Type /bmud for usage",0,192,255)
	end
end

for k, v in pairs(RegisteredEvents) do
	BMUDslash:RegisterEvent(k)
end

function BeamMeUpDeja.ShowHelp()
	print("BeamMeUpDeja Slash commands (/bmud):")
	print("  /bmud lock: Locks all BeamMeUpDeja movable frames.")
	print("  /bmud unlock: Unlocks all BeamMeUpDeja movable frames.")
	print("  /bmud config: Open the BeamMeUpDeja addon config menu.")
	print("  /bmud reset:  Resets BeamMeUpDeja frames to default positions.")
end

function BeamMeUpDeja.SetConfigToDefaults()
	print("Resetting config to defaults")
	BeamMeUpDejaDBPC = DefaultConfig
	RELOADUI()
end

function BeamMeUpDeja.GetConfigValue(key)
	return BeamMeUpDejaDBPC[key]
end

function BeamMeUpDeja.PrintPerformanceData()
	UpdateAddOnMemoryUsage()
	local mem = GetAddOnMemoryUsage("BeamMeUpDeja")
	print("BeamMeUpDeja is currently using " .. mem .. " kbytes of memory")
	collectgarbage(collect)
	UpdateAddOnMemoryUsage()
	mem = GetAddOnMemoryUsage("BeamMeUpDeja")
	print("BeamMeUpDeja is currently using " .. mem .. " kbytes of memory after garbage collection")
end

function BeamMeUpDeja.SlashCmdHandler(msg, editbox)
	--print("command is " .. msg .. "\n")
	if (string.lower(msg) == "config") then
		InterfaceOptionsFrame_OpenToCategory("BeamMeUpDeja");
	elseif (string.lower(msg) == "dumpconfig") then
		print("With defaults")
		for k,v in pairs(BMUDDefaultConfig) do
			print(k,BeamMeUpDeja.GetConfigValue(k))
		end
		print("Direct table")
		for k,v in pairs(BMUDDefaultConfig) do
			print(k,v)
		end
	elseif (string.lower(msg) == "lock") then
		BMUDlockcheckframe:Hide()
		BMUDlockcheck:SetChecked(true)
	elseif (string.lower(msg) == "unlock") then
		BMUDlockcheckframe:Show()
		BMUDlockcheck:SetChecked(false)
	elseif (string.lower(msg) == "reset") then
		BeamMeUpDejaDBPC = private.defaults;
		ReloadUI();
	elseif (string.lower(msg) == "perf") then
		BeamMeUpDeja.PrintPerformanceData()
	else
		BeamMeUpDeja.ShowHelp()
	end
end
	SlashCmdList["BEAMMEUPDEJA"] = BeamMeUpDeja.SlashCmdHandler;

-- BeamMeUpDeja
local name,addon = ...
local _, gdbprivate = ...

	-- itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, 
	-- itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = 
	-- GetItemInfo(itemID or "itemString" or "itemName" or "itemLink")

local function ddebug()
	local status = issecurevariable("BMUDButton")
	local info = "Frame is %s tainted"
	local addend = ""
	if status then addend = "not" end
	info = format(info,addend)
	print(info," on loop")
end

private.defaults.BMUDDragFrameSetPoints = {
	point = "CENTER", 
	relativeTo = "UIParent", 
	relativePoint = "CENTER", 
	xOffset = 0, 
	yOffset = 0,
}	
	
local BeamMeUpDejaDragFrame = CreateFrame("Frame", "BeamMeUpDejaDragFrame", UIParent)
	BeamMeUpDejaDragFrame:RegisterEvent("PLAYER_LOGIN")
	BeamMeUpDejaDragFrame:SetClampedToScreen(true)
	BeamMeUpDejaDragFrame:ClearAllPoints()
	BeamMeUpDejaDragFrame:SetPoint("CENTER", UIParent, 0, 0)
	BeamMeUpDejaDragFrame:SetScale(1)
	BeamMeUpDejaDragFrame:SetWidth(275)
	BeamMeUpDejaDragFrame:SetHeight(150)
	BeamMeUpDejaDragFrame:Show()

	--Basic draggable frames
	BeamMeUpDejaDragFrame:RegisterForDrag("LeftButton")
	--BeamMeUpDejaDragFrame:EnableMouse(true)
	--BeamMeUpDejaDragFrame:SetMovable(true)
	BeamMeUpDejaDragFrame:SetScript("OnDragStart", BeamMeUpDejaDragFrame.StartMoving)
	BeamMeUpDejaDragFrame:SetScript("OnDragStop", BeamMeUpDejaDragFrame.StopMovingOrSizing)

	--Debugging Texture
	--local BeamMeUpDejaDragFrametexture=BeamMeUpDejaDragFrame:CreateTexture(nil,"ARTWORK")
	--BeamMeUpDejaDragFrametexture:SetAllPoints(BeamMeUpDejaDragFrame)
	--BeamMeUpDejaDragFrametexture:SetColorTexture(1, 1, 1, 0.7)

	BeamMeUpDejaDragFrame:SetScript("OnEvent", function(self, event, ...)
		if event == "PLAYER_LOGIN" then
			local point = private.db.BMUDDragFrameSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)

	BeamMeUpDejaDragFrame:SetScript("OnDragStart", BeamMeUpDejaDragFrame.StartMoving) 
	
	BeamMeUpDejaDragFrame:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)

		private.db.BMUDDragFrameSetPoints.point = point
		private.db.BMUDDragFrameSetPoints.relativeTo = relativeTo
		private.db.BMUDDragFrameSetPoints.relativePoint = relativePoint
		private.db.BMUDDragFrameSetPoints.xOffset = xOfs
		private.db.BMUDDragFrameSetPoints.yOffset = yOfs			
	end)
	
	
local BeamMeUpDejaHideFrame = CreateFrame("Frame", "BeamMeUpDejaHideFrame", BeamMeUpDejaDragFrame)
	BeamMeUpDejaHideFrame:RegisterEvent("PLAYER_LOGIN")
	BeamMeUpDejaHideFrame:SetClampedToScreen(true)
	BeamMeUpDejaHideFrame:ClearAllPoints()
	BeamMeUpDejaHideFrame:SetPoint("BOTTOMRIGHT", BeamMeUpDejaDragFrame, "BOTTOMRIGHT", 0, 0)
	BeamMeUpDejaHideFrame:SetScale(1)
	BeamMeUpDejaHideFrame:SetWidth(275)
	BeamMeUpDejaHideFrame:SetHeight(150)
	
	--Debugging Texture
	--local BeamMeUpDejaHideFrametexture=BeamMeUpDejaHideFrame:CreateTexture(nil,"ARTWORK")
	--BeamMeUpDejaHideFrametexture:SetAllPoints(BeamMeUpDejaHideFrame)
	--BeamMeUpDejaHideFrametexture:SetColorTexture(0, 0.75, 1, 0.7)

local Ecount
local Rcount
local Ucount

local function dosomething()
	for bag = 0, 4, 1 do 
		for slot=1, GetContainerNumSlots(bag), 1 do 
			local name = GetContainerItemLink(bag,slot)
			if name and string.find(name,"Sentinax Beacon") then
			--if name and string.find(name,"Hearthstone") then
				--ddebug()
				local itemName, itemLink, itemRarity,_,_,_,_,itemStackCount,_,itemTexture,_ = GetItemInfo(name)
					--print(name, itemName,itemStackCount)--Debugging
				local texture = select(10,GetItemInfo(name))
				local w = 36
				local h = 36
				local x
				local y = 0
				if itemRarity == 4 then
					--print("Ecount is "..Ecount)--Debugging
					x = (Ecount*w)*1.1
					y = h*2.1
					Ecount = Ecount+1
				end
				if itemRarity == 3 then
					--print("Rcount is "..Rcount)--Debugging
					x = (Rcount*w)*1.1
					y = h*1.1
					Rcount = Rcount+1
				end
				if itemRarity == 2 then
					--print("Ucount is "..Ucount)--Debugging
					x = (Ucount*w)*1.1
					Ucount = Ucount+1
				end
				
				BMUDButton = CreateFrame("Button", "KStatFrame"..name, BeamMeUpDejaHideFrame, "SecureActionButtonTemplate");
				_G["BMUDButton"..name] = BMUDButton
				
					BMUDButton:RegisterForClicks("AnyUp", "AnyDown")
					BMUDButton:ClearAllPoints()
					BMUDButton:SetPoint("BOTTOMLEFT",x,y+32)
					BMUDButton:SetScale(1)
					BMUDButton:SetSize(w,h)
					BMUDButton:SetNormalTexture(itemTexture)
					BMUDButton:SetPushedTexture(itemTexture)
					BMUDButton:SetHighlightTexture(itemTexture)
					
					BMUDButton:SetAttribute("type","item")
					BMUDButton:SetAttribute("item",itemName)

					BMUDButton:HookScript("OnMouseUp", function(self) 
						--print(name)--Debugging
						self:SetScale(1)
					end)
					
					BMUDButton:HookScript("OnMouseDown", function(self) 
						--print(name)--Debugging
						self:SetScale(1.02)
					end)
				BMUDButton:HookScript("OnEnter", function(self)
					GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
					GameTooltip:SetHyperlink(name)
					GameTooltip:Show()
				end)

				BMUDButton:HookScript("OnLeave", function(self) GameTooltip:Hide() end)
			end
		end 
	end
end

private.defaults.BMUDShowHideButtonChecked = {
	BMUDShowHideButtonShownCheck = true,
}	

local ShowHideButtonShownCheck

local function BeamMeUpDejaShowHideTooltipChangeText()
	GameTooltip:SetOwner(BeamMeUpDejaShowHideButton, "ANCHOR_RIGHT");
	GameTooltip:SetText(BeamMeUpDejaShowHideButtontooltipText, 1, 1, 1, 1, true)
end

local BeamMeUpDejaShowHideButton = CreateFrame("Button", "BeamMeUpDejaShowHideButton", UIParent)
	BeamMeUpDejaShowHideButton:RegisterEvent("PLAYER_LOGIN")
	BeamMeUpDejaShowHideButton:ClearAllPoints()
	BeamMeUpDejaShowHideButton:SetPoint("BOTTOMLEFT", BeamMeUpDejaHideFrame, "BOTTOMLEFT", 0, 0)
	BeamMeUpDejaShowHideButton:SetScale(1)
	BeamMeUpDejaShowHideButton:SetWidth(116)
	BeamMeUpDejaShowHideButton:SetHeight(30)
	BeamMeUpDejaShowHideButton:SetFrameStrata("TOOLTIP")
	BeamMeUpDejaShowHideButton:Show()

	--Button Color
local BeamMeUpDejaShowHideButtonTexture=BeamMeUpDejaShowHideButton:CreateTexture(nil,"ARTWORK")
	BeamMeUpDejaShowHideButtonTexture:SetAllPoints(BeamMeUpDejaShowHideButton)
	BeamMeUpDejaShowHideButtonTexture:SetColorTexture(0, 0.75, 1, 1)

local BeamMeUpDejaShowHideButtonFS = BeamMeUpDejaShowHideButton:CreateFontString("FontString","OVERLAY","GameTooltipText")
	BeamMeUpDejaShowHideButtonFS:SetPoint("CENTER", BeamMeUpDejaShowHideButton)
	BeamMeUpDejaShowHideButtonFS:SetFont("Fonts\\MORPHEUS.TTF", 20)
	BeamMeUpDejaShowHideButtonFS:SetShadowOffset(1, -1)
	BeamMeUpDejaShowHideButtonFS:SetTextColor(1, 1, 0);
	BeamMeUpDejaShowHideButtonFS:SetText("")

			
	BeamMeUpDejaShowHideButton:SetScript("OnEvent", function(self, button, up)
		Ecount = 0
		Rcount = 0
		Ucount = 0	
		ShowHideButtonShownCheck = private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck
		if ShowHideButtonShownCheck == true then
			dosomething()
			BeamMeUpDejaHideFrame:Show()
			BMUDButton:Show()
			BeamMeUpDejaShowHideButtontooltipText = ("Hide the Sentinax beacon buttons.") --Creates a tooltip on mouseover.
			BeamMeUpDejaShowHideButtonFS:SetText("Hide")
			--print("Shown")--Debugging
			private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck = true
		else
			BeamMeUpDejaHideFrame:Hide()
			BeamMeUpDejaShowHideButtontooltipText = ("Show buttons for Sentinax beacons in your bags.") --Creates a tooltip on mouseover.
			BeamMeUpDejaShowHideButtonFS:SetText("Show")
			--print("Hidden")--Debugging
			private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck = false
		end
	end)
	
	BeamMeUpDejaShowHideButton:SetScript("OnClick", function(self, button, up)
		if not InCombatLockdown() then 
			if ShowHideButtonShownCheck == true then
				BeamMeUpDejaHideFrame:Hide()
				BeamMeUpDejaShowHideButtontooltipText = ("Show buttons for Sentinax beacons in your bags.") --Creates a tooltip on mouseover.
				BeamMeUpDejaShowHideButtonFS:SetText("Show")
				BeamMeUpDejaShowHideTooltipChangeText()
				private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck = false
				--print("Hidden")--Debugging
			else
				dosomething()
				BeamMeUpDejaHideFrame:Show()
				BMUDButton:Show()
				BeamMeUpDejaShowHideButtontooltipText = ("Hide the Sentinax beacon buttons.") --Creates a tooltip on mouseover.
				BeamMeUpDejaShowHideButtonFS:SetText("Hide")
				BeamMeUpDejaShowHideTooltipChangeText()
				private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck = true
				--print("Shown")--Debugging
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("BeamMeUpDeja beacon buttons cannot be created or hidden while in combat.",0,192,255)
		end
		ShowHideButtonShownCheck = private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck
		Ecount = 0
		Rcount = 0
		Ucount = 0
	end)
 
 	BeamMeUpDejaShowHideButton:SetScript("OnEnter", function(self)
		BeamMeUpDejaShowHideTooltipChangeText()
		GameTooltip:Show()
	end)

	BeamMeUpDejaShowHideButton:SetScript("OnLeave", function(self)
		GameTooltip_Hide()
	end)
	
local BeamMeUpDejaOOCFrame = CreateFrame("Frame", "BeamMeUpDejaOOCFrame", BeamMeUpDejaDragFrame)
	BeamMeUpDejaOOCFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
	BeamMeUpDejaOOCFrame:RegisterEvent("LOOT_OPENED")

	BeamMeUpDejaOOCFrame:SetScript("OnEvent", function(self, event, ...)
		if not InCombatLockdown() then 
			Ecount = 0
			Rcount = 0
			Ucount = 0	
			ShowHideButtonShownCheck = private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck
			if ShowHideButtonShownCheck == true then
				dosomething()
				BeamMeUpDejaHideFrame:Show()
				BMUDButton:Show()
				BeamMeUpDejaShowHideButtontooltipText = ("Hide the Sentinax beacon buttons.") --Creates a tooltip on mouseover.
				BeamMeUpDejaShowHideButtonFS:SetText("Hide")
				--print("Shown")--Debugging
				private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck = true
			else
				BeamMeUpDejaHideFrame:Hide()
				BeamMeUpDejaShowHideButtontooltipText = ("Show buttons for Sentinax beacons in your bags.") --Creates a tooltip on mouseover.
				BeamMeUpDejaShowHideButtonFS:SetText("Show")
				--print("Hidden")--Debugging
				private.db.BMUDShowHideButtonChecked.BMUDShowHideButtonShownCheck = false
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("BeamMeUpDeja beacon buttons cannot be created or hidden while in combat.",0,192,255)
		end
	end)

	--Nethershard Parent Frame
local NethershardFrame = CreateFrame("Frame", "NethershardFrame", UIParent)
	NethershardFrame:RegisterEvent("PLAYER_LOGIN")
	NethershardFrame:ClearAllPoints()
	NethershardFrame:SetPoint("TOPLEFT", BeamMeUpDejaShowHideButton, "TOPRIGHT", 2, 0)
	--NethershardFrame:SetFrameStrata("TOOLTIP")--Debugging
	NethershardFrame:SetScale(1)
	NethershardFrame:SetWidth(160)
	NethershardFrame:SetHeight(30)
	NethershardFrame:Show()

	--Debugging Texture
local NethershardFrameTexture=NethershardFrame:CreateTexture(nil,"ARTWORK")
	NethershardFrameTexture:SetAllPoints(NethershardFrame)
	NethershardFrameTexture:SetColorTexture(0.3, 0.75, 0.1, 1)

	--Nethershard Icon Frame
local NethershardIconFrame = CreateFrame("Frame", "NethershardIconFrame", UIParent)
	NethershardIconFrame:RegisterEvent("PLAYER_LOGIN")
	NethershardIconFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
	NethershardIconFrame:ClearAllPoints()
	NethershardIconFrame:SetPoint("TOPLEFT", NethershardFrame, "TOPLEFT", 0, 0)
	NethershardIconFrame:SetScale(1)
	NethershardIconFrame:SetWidth(14)
	NethershardIconFrame:SetHeight(14)
	NethershardIconFrame:SetFrameStrata("TOOLTIP")
	NethershardIconFrame:Show()
	
local NethershardFS = NethershardFrame:CreateFontString("FontString","OVERLAY","GameTooltipText")
	NethershardFS:SetPoint("LEFT", NethershardIconFrame, "RIGHT", -1, 1)
	NethershardFS:SetFont("Fonts\\MORPHEUS.TTF", 16)
	NethershardFS:SetFormattedText("")
	NethershardFS:SetShadowOffset(1, -1)
	NethershardFS:SetTextColor(1, 1, 1, 1);
	NethershardFS:Show()

local NethershardFSTexture=NethershardIconFrame:CreateTexture(nil,"ARTWORK")
	NethershardFSTexture:SetAllPoints(NethershardIconFrame)
			
	NethershardIconFrame:SetScript("OnEvent", function(self, event, ...)
		local name, currentAmount, texture, _, _, totalMax = GetCurrencyInfo(1226)--Nethershards
		NethershardFS:SetFormattedText("Nethershards: %.0f", currentAmount)
		--NethershardFS:SetText("Nethershards: "..currentAmount);
		NethershardFSTexture:SetTexture(texture)
	end)

local LWSuppliesIconFrame = CreateFrame("Frame", "LWSuppliesIconFrame", UIParent)
	LWSuppliesIconFrame:RegisterEvent("PLAYER_LOGIN")
	LWSuppliesIconFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
	LWSuppliesIconFrame:ClearAllPoints()
	LWSuppliesIconFrame:SetPoint("BOTTOMLEFT", NethershardFrame, "BOTTOMLEFT", 0, 0)
	LWSuppliesIconFrame:SetScale(1)
	LWSuppliesIconFrame:SetWidth(14)
	LWSuppliesIconFrame:SetHeight(14)
	LWSuppliesIconFrame:SetFrameStrata("TOOLTIP")
	LWSuppliesIconFrame:Show()
	
local LWSuppliesFS = NethershardFrame:CreateFontString("FontString","OVERLAY","GameTooltipText")
	LWSuppliesFS:SetPoint("LEFT", LWSuppliesIconFrame, "RIGHT", -1, 0)
	LWSuppliesFS:SetFont("Fonts\\MORPHEUS.TTF", 16)
	LWSuppliesFS:SetFormattedText("")
	LWSuppliesFS:SetShadowOffset(1, -1)
	LWSuppliesFS:SetTextColor(1, 1, 1, 1);
	NethershardFS:Show()

local LWSuppliesFSTexture=LWSuppliesIconFrame:CreateTexture(nil,"ARTWORK")
	LWSuppliesFSTexture:SetAllPoints(LWSuppliesIconFrame)
	LWSuppliesFSTexture:SetTexture(texture)
			
			
	LWSuppliesIconFrame:SetScript("OnEvent", function(self, event, ...)
		local name, currentAmount, texture, _, _, totalMax = GetCurrencyInfo(1342)--Legionfall War Supplies
		LWSuppliesFS:SetFormattedText("War  Supplies: %.0f", currentAmount)
		--NethershardFS:SetText("War  Supplies: "..currentAmount);
		LWSuppliesFSTexture:SetTexture(texture)
	end)	

private.defaults.BMUDLockChecked = {
	BMUDLockSetChecked = false,
}	

local function BMUD_LockCheckTooltipChangeText()
	GameTooltip:SetOwner(BMUD_LockCheck, "ANCHOR_RIGHT");
	GameTooltip:SetText(BMUD_LockCheckButtontooltipText, 1, 1, 1, 1, true)
end

local checked

local BMUD_LockCheck = CreateFrame("Button", "BMUD_LockCheck", NethershardFrame)
	BMUD_LockCheck:RegisterEvent("PLAYER_LOGIN")
	BMUD_LockCheck:ClearAllPoints()
	BMUD_LockCheck:SetPoint("RIGHT", -6, 34)
	BMUD_LockCheck:SetScale(1)
	BMUD_LockCheck:SetSize(36, 36)
	BMUD_LockCheck:SetNormalTexture("Interface\\Buttons\\LockButton-Locked-Up")
	BMUD_LockCheck:SetPushedTexture("Interface\\Buttons\\LockButton-Unlocked-Down")
	BMUD_LockCheck:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
	
BMUD_LockCheck:SetScript("OnEvent", function(self, event, ...)
	checked = private.db.BMUDLockChecked.BMUDLockSetChecked
	if checked == true then
		BeamMeUpDejaDragFrame:EnableMouse(false)
		BeamMeUpDejaDragFrame:SetMovable(false)
		BMUD_LockCheck:SetNormalTexture("Interface\\Buttons\\LockButton-Locked-Up")
		BMUD_LockCheckButtontooltipText = ("Unlock") --Creates a tooltip on mouseover.
		private.db.BMUDLockChecked.BMUDLockSetChecked = true
		--print("true")--Debugging
	else
		BeamMeUpDejaDragFrame:EnableMouse(true)
		BeamMeUpDejaDragFrame:SetMovable(true)
		BMUD_LockCheck:SetNormalTexture("Interface\\Buttons\\LockButton-Unlocked-Up")
		BMUD_LockCheckButtontooltipText = ("Lock") --Creates a tooltip on mouseover.
		private.db.BMUDLockChecked.BMUDLockSetChecked = false
		--print("false")--Debugging
	end
end)

BMUD_LockCheck:SetScript("OnClick", function(self,event,arg1) 
	if checked == true then
		BeamMeUpDejaDragFrame:EnableMouse(true)
		BeamMeUpDejaDragFrame:SetMovable(true)
		BMUD_LockCheck:SetNormalTexture("Interface\\Buttons\\LockButton-Unlocked-Up")
		BMUD_LockCheckButtontooltipText = ("Lock") --Creates a tooltip on mouseover.
		BMUD_LockCheckTooltipChangeText()
		BMUD_LockCheck.tooltip = ("Lock") --Creates a tooltip on mouseover.
		private.db.BMUDLockChecked.BMUDLockSetChecked = false
		--print("false")--Debugging
	else
		BeamMeUpDejaDragFrame:EnableMouse(false)
		BeamMeUpDejaDragFrame:SetMovable(false)
		BMUD_LockCheck:SetNormalTexture("Interface\\Buttons\\LockButton-Locked-Up")
		BMUD_LockCheckButtontooltipText = ("Unlock") --Creates a tooltip on mouseover.
		BMUD_LockCheckTooltipChangeText()
		private.db.BMUDLockChecked.BMUDLockSetChecked = true
		--print("true")--Debugging
	end
	checked = private.db.BMUDLockChecked.BMUDLockSetChecked
end)

 	BMUD_LockCheck:SetScript("OnEnter", function(self)
		BMUD_LockCheckTooltipChangeText()
		GameTooltip:Show()
	end)

	BMUD_LockCheck:SetScript("OnLeave", function(self)
		GameTooltip_Hide()
	end)